;===================================
;Variable Usage

;var(2)	  Hitpause Helper!
;var(4)   Burst Counter
;var(6)   Jump Counter
;var(11)  Last Recorded HitType
;var(12)  Last Known HitType
;var(13)  Random Effects
;var(14)  Ekoda Shiki Chain Preventer
;var(15)  Airdash counter

;fvar(3)  Combo Dampener
;fvar(4)  Combo Dampener
;fvar(5)  combo Dampener


;====================================
;Airdash
[Statedef 60]
type = A
movetype = I
physics = A
sprpriority = 2

[State Effect Reset]
type = removeexplod
trigger1 = !time
ID = 1

[State 60, Varset]
type = varset
trigger1 = time = 0
var(15) = 1

[State 60, Velocity]
type = velset
trigger1 = time = 0
x = ifelse(command = "holdfwd",6,-3.825)
y = 0

[State 60, Velocity]
type = veladd
trigger1 = time = (5,18]
trigger1 = vel x < -2.50
x = .1019

[State 60, Velocity]
type = velset
trigger1 = animelemtime(5) = 0
trigger1 = vel x > 4.4
x = 4.4

[State 60, Gravity]
type = veladd
trigger1 = time <= 18
trigger1 = vel x < 0
trigger2 = animelemtime(5) <= 0
trigger2 = vel x > 0
y = -.44

[State 60, Sound]
type = Playsnd
trigger1 = time = 1
trigger1 = vel x < 0
value = 65, 1

[State 60, Sound]
type = Playsnd
trigger1 = time = 1
trigger1 = vel x > 0
value = 65, 0

[State 60, Effects]
type = Explod
trigger1 = time <= 18
trigger1 = vel x < 0
trigger2 = animelemtime(5) <= 0
trigger2 = vel x > 0
anim = 11030
ID = 60
pos = floor(-1 * Vel X) * 8, -60
postype = p1
bindtime = 1
random = 0, 50
scale = const(size.xscale),const(size.yscale)
sprpriority = -2
ownpal = 1
persistent = 2
pausemovetime = 65535

[State 60, Effects]
type = Explod
trigger1 = vel x > 0
anim = 111
ID = 1
bindtime = -1
scale = const(size.xscale),const(size.yscale)
sprpriority = 3
ownpal = 1
persistent = 0
removeongethit = 1
pausemovetime = 65535

[State 60, Effects]
type = Explod
trigger1 = vel x > 0
anim = 112
ID = 1
bindtime = -1
scale = const(size.xscale),const(size.yscale)
sprpriority = 3
ownpal = 1
persistent = 0
removeongethit = 1
pausemovetime = 65535

[State 60, Anim]
type = changeAnim
trigger1 = time = 0
trigger1 = vel x > 0
value = 110

[State 60, Anim]
type = changeAnim
trigger1 = time = 0
trigger1 = vel x < 0
value = 113

[State 60, Stop]
type = Changeanim
trigger1 = anim = [110,113]
trigger1 = AnimTime = 0
value = 44
elem = 6




;=================================
;Superjump Start
[Statedef 65]
type    = S
physics = S
anim = 54
ctrl = 0
sprpriority = 1
facep2 = 1

[State Effect Reset]
type = removeexplod
trigger1 = !time
ID = 1

[State 65, 1]
type = VarSet
trigger1 = Time = 0
sysvar(1) = 0

[State 65, 2]
type = VarSet
trigger1 = command = "holdfwd"
sysvar(1) = 1

[State 65, 3]
type = VarSet
trigger1 = command = "holdback"
sysvar(1) = -1

[State 65, 4]
type = VelSet
trigger1 = AnimTime = 0
x = sysvar(1)
y = const(velocity.jump.y)-3.5

[State 65, 5]
type = ChangeState
trigger1 = AnimTime = 0
value = 50
ctrl = 1


;=================================
;Burst
[Statedef 70]
type    = A
movetype = I
physics = N
anim = 6000
ctrl = 0
sprpriority = 4
facep2 = 1
velset = 0,0

[State Effect Reset]
type = removeexplod
trigger1 = !time
ID = 1

[State 70, posadd]
type = posadd
trigger1 = !time
y = -1

[State 70, Superpause]
type = superpause
trigger1 = !time
anim = -1
time = 130
sound = -1
darken = 1
movetime = 130

[State 70, Effect]
type = playsnd
trigger1 = time = 16
value = 6000,1

[State 4030, Explod]
type = Explod
trigger1 = time = 53
anim = 20212
ID = 20212
postype = back
pos = 0,0
supermovetime = 100
bindtime = 9999
removetime = 80
shadow = -1
scale = const(size.xscale),const(size.yscale)
sprpriority = -3
removeongethit = 1
supermovetime = 65535
pausemovetime = 65535

[State 4030, Explod]
type = Explod
trigger1 = time = 53
anim = 20209
ID = 20209
pos = 0,-69
supermovetime = 100
bindtime = 9999
removetime = 80
shadow = -1
scale = const(size.xscale),const(size.yscale)
sprpriority = 5
removeongethit = 1
supermovetime = 65535
pausemovetime = 65535

[State 4010, FadeIn]
type = modifyexplod
trigger1 = time = [53,69]
trigger1 = numexplod(20212)
ID = 20212
trans = addalpha
alpha = ceil(((time-53)/16.0)*256),256
supermovetime = 65535
pausemovetime = 65535

[State 4010, FadeOut]
type = modifyexplod
trigger1 = time = [87,104]
trigger1 = numexplod(20212)
ID = 20212
trans = addalpha
alpha = ceil(((104-time)/17.0)*256),256
supermovetime = 65535
pausemovetime = 65535

[State 4010, FadeWtf]
type = modifyexplod
trigger1 = time = [53,85]
trigger1 = numexplod(20209)
ID = 20209
trans = addalpha
alpha = ceil(((time-53)/32.0)*128),256
scale = const(size.xscale)*(time-53)/32.0,const(size.yscale)*(time-53)/32.0
supermovetime = 65535
pausemovetime = 65535

[State 4010, FadeWtf]
type = modifyexplod
trigger1 = time = [86,111]
trigger1 = numexplod(20209)
ID = 20209
trans = addalpha
alpha = ceil(((111-time)/25.0)*256),256
scale = const(size.xscale)*(time-86)*3.0+1.0,const(size.yscale)*(time-86)*3.0+1.0
supermovetime = 65535
pausemovetime = 65535

[State 70, Talk]
type = playsnd
trigger1 = time = 0
value = 6000,0
channel = 1
volume = 255

[State 70, Fly!]
type = changeanim
trigger1 = time = 16
value = 6001
supermovetime = 65535
pausemovetime = 65535

[State 70, Fly!]
type = velset
trigger1 = time = 16
y = -1
supermovetime = 65535
pausemovetime = 65535

[State 70, Stop]
type = velset
trigger1 = time = 73
y = 0
supermovetime = 65535
pausemovetime = 65535

[State 70, Fly!]
type = velset
trigger1 = time = 105
y = 1
supermovetime = 65535
pausemovetime = 65535


[State 70, var]
type = varset
trigger1 = time = 130
v = 4
value = 1
supermovetime = 65535
pausemovetime = 65535

[State 70, End]
type = changestate
trigger1 = time = 130
value = 50
ctrl = 1
supermovetime = 65535
pausemovetime = 65535

;=================================
;Spark
[Statedef 11000]
type = A
movetype = I
physics = N
anim = 11100
sprpriority = 4

[State 11000, Noshadow]
type = assertspecial
trigger1 = 1
flag = noshadow

[State 11005, Anim]
type = changeanim
trigger1 = ishelper(11000)
value = 11000
persistent = 0
ignorehitpause = 1

[State 11005, Anim]
type = changeanim
trigger1 = ishelper(11001)
trigger2 = ishelper(11103)
value = 11001
persistent = 0
ignorehitpause = 1

[State 11005, Anim]
type = changeanim
trigger1 = ishelper(11002)
value = 11002
persistent = 0
ignorehitpause = 1

[State 11005, Anim]
type = changeanim
trigger1 = ishelper(11003)
value = 11101
persistent = 0
ignorehitpause = 1

[State 11005, Anim]
type = changeanim
trigger1 = ishelper(11004)
trigger2 = ishelper(11005)
value = 11008
persistent = 0
ignorehitpause = 1

[State 11005, Anim]
type = changeanim
trigger1 = ishelper(11006)
value = 11011
persistent = 0
ignorehitpause = 1

[State 200, hitspark]
type = Helper
trigger1 = anim = 11011
stateno = 11006
name = "Star"
ID = 11011
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = 11011
stateno = 11006
name = "Star"
ID = 11012
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = 11011
stateno = 11006
name = "Star"
ID = 11013
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = 11011
stateno = 11006
name = "Star"
ID = 11014
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = 11011
stateno = 11006
name = "Star"
ID = 11015
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = 11011
stateno = 11006
name = "Star"
ID = 11016
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = 11011
stateno = 11006
name = "Star"
ID = 11017
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 11005]
type = AngleSet
trigger1 = ishelper(11005)
value = -65
ignorehitpause = 1

[State 11005]
type = AngleDraw
trigger1 = ishelper(11004)
trigger2 = ishelper(11005)
scale = 2.0,2.0
ignorehitpause = 1

[State 11005]
type = trans
trigger1 = 1
trans = add

[State 11005, Pos]
type = posset
trigger1 = anim>=11100
x = enemy, pos X + enemy, const(size.ground.front) * facing
y = enemy, pos Y + enemy, const(size.mid.pos.y)

[State 200, hitspark]
type = Helper
trigger1 = time = 0
trigger1 = anim != 11011
stateno = 11004
name = "Effect"
ID = ifelse(anim<11100,11004,11102)
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = time = 0
trigger1 = anim != 11011
stateno = 11004
name = "Effect"
ID = ifelse(anim<11100,11004,11102)
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = time = 0
trigger1 = anim != 11011
stateno = 11004
name = "Effect"
ID = ifelse(anim<11100,11004,11102)
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = time = 0
trigger1 = anim != 11011
stateno = 11004
name = "Effect"
ID = ifelse(anim<11100,11004,11102)
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = time = 0
trigger1 = anim != 11011
stateno = 11004
name = "Effect"
ID = ifelse(anim<11100,11004,11102)
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = time = 0
trigger1 = anim != 11011
stateno = 11004
name = "Effect"
ID = ifelse(anim<11100,11004,11102)
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = time = 0
trigger1 = anim != 11011
stateno = 11004
name = "Effect"
ID = ifelse(anim<11100,11004,11102)
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = [11000,11003]
stateno = 11005
name = "Small Spark"
ID = 11005
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = [11000,11003]
stateno = 11005
name = "Small Spark"
ID = 11005
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = [11000,11008]
stateno = 11005
name = "Medium Spark"
ID = 11006
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = [11001,11008]
stateno = 11005
name = "Medium Spark"
ID = 11006
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = [11001,11008]
stateno = 11005
name = "Heavy Spark"
ID = 11007
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = [11002,11008]
stateno = 11005
name = "Heavy Spark"
ID = 11007
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = [11002,11008]
stateno = 11005
name = "Heavy Spark"
ID = 11007
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = 11008
stateno = 11005
name = "Heavy Spark"
ID = 11007
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = 11008
stateno = 11005
name = "Heavy Spark"
ID = 11007
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = 11008
stateno = 11005
name = "Heavy Spark"
ID = 11007
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = 11011
stateno = 11006
name = "Cloud"
ID = 11008
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, hitspark]
type = Helper
trigger1 = anim = 11011
stateno = 11006
name = "Cloud"
ID = 11008
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, guardspark]
type = Helper
trigger1 = ishelper(11102)
trigger2 = ishelper(11101)
trigger3 = ishelper(11100)
trigger4 = ishelper(11103)
stateno = 11005
name = "Small Guard Spark"
ID = 11103
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, guardspark]
type = Helper
trigger1 = ishelper(11102)
trigger2 = ishelper(11101)
trigger3 = ishelper(11100)
trigger4 = ishelper(11103)
stateno = 11005
name = "Small Guard Spark"
ID = 11103
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, guardspark]
type = Helper
trigger1 = ishelper(11102)
trigger2 = ishelper(11101)
trigger3 = ishelper(11103)
stateno = 11005
name = "Small Guard Spark"
ID = 11103
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, guardspark]
type = Helper
trigger1 = ishelper(11102)
trigger2 = ishelper(11101)
trigger3 = ishelper(11103)
stateno = 11005
name = "Small Guard Spark"
ID = 11103
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, guardspark]
type = Helper
trigger1 = ishelper(11102)
stateno = 11005
name = "Small Guard Spark"
ID = 11103
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 200, guardspark]
type = Helper
trigger1 = ishelper(11102)
stateno = 11005
name = "Small Guard Spark"
ID = 11103
pos = 0,0
ownpal = 1
ignorehitpause = 1
pausemovetime = 999
persistent = 0

[State 11000, End]
type = destroyself
trigger1 = animtime = 0

[Statedef 11005]
type = A
movetype = I
physics = N
sprpriority = 5

[State 11000, Noshadow]
type = assertspecial
trigger1 = 1
flag = noshadow

[State 11005, Anim]
type = changeanim
trigger1 = ishelper(11007)
value = 11007
persistent = 0
ignorehitpause = 1

[State 11005, Anim]
type = changeanim
trigger1 = ishelper(11006)
value = 11006
persistent = 0
ignorehitpause = 1

[State 11005, Anim]
type = changeanim
trigger1 = ishelper(11005)
value = 11005
persistent = 0
ignorehitpause = 1

[State 11005, Anim]
type = changeanim
trigger1 = ishelper(11103)
value = 11103
persistent = 0
ignorehitpause = 1

[State 11005, Anim]
type = changeanim
trigger1 = ishelper(11008)
value = 11010
persistent = 0
ignorehitpause = 1

[State 11005]
type = varset
trigger1 = 1
fv = 1
value = random%360
persistent = 0
ignorehitpause = 1

[State 11005]
type = varset
trigger1 = 1
fv = 2
value = (random%6/2.0 + 3) * 3.0
persistent = 0
ignorehitpause = 1

[State 11005]
type = AngleSet
trigger1 = 1
value = fvar(1)
ignorehitpause = 1

[State 11005]
type = AngleDraw
trigger1 = 1
ignorehitpause = 1

;sin(0)*hypotenuse = opposite
;cos(0)*hypotenuse = adjacent

[State 11005]
type = posadd
trigger1 = 1
x = cos((fvar(1)+90.0)*pi/180.0) * fvar(2)
y = -1 * sin((fvar(1)+90.0)*pi/180.0) * fvar(2)
persistent = 0
ignorehitpause = 1

[State 11005]
type = velset
trigger1 = 1
x = cos((fvar(1)+90.0)*pi/180.0) * fvar(2)
y = -1 * sin((fvar(1)+90.0)*pi/180.0) * fvar(2)
persistent = 0
ignorehitpause = 1

[State 11005]
type = trans
trigger1 = 1
trans = addalpha
alpha = 200,255
ignorehitpause = 1

[State 11005, End]
type = destroyself
trigger1 = animtime = 0
ignorehitpause = 1

[Statedef 11004]
type = A
movetype = I
physics = N
sprpriority = 5

[State 11000, Noshadow]
type = assertspecial
trigger1 = 1
flag = noshadow

[State 11004]
type = changeanim
trigger1 = ishelper(11004)
value = 11004
ignorehitpause=1
persistent = 0

[State 11004]
type = changeanim
trigger1 = ishelper(11102)
value = 11102
ignorehitpause=1
persistent = 0

[State 11005]
type = trans
trigger1 = 1
trans = addalpha
alpha = 200,255
ignorehitpause = 1

[State 11005]
type = varset
trigger1 = 1
fv = 1
value = random%360
persistent = 0
ignorehitpause = 1

[State 11005]
type = varset
trigger1 = 1
v = 1
value = random%3 + 1
persistent = 0
ignorehitpause = 1

[State 11005]
type = AngleSet
trigger1 = 1
value = fvar(1)
ignorehitpause = 1

[State 11005]
type = AngleDraw
trigger1 = 1
ignorehitpause = 1

;sin(0)*hypotenuse = opposite
;cos(0)*hypotenuse = adjacent

[State 11005]
type = posadd
trigger1 = 1
x = cos((fvar(1)+90.0)*pi/180.0) * var(1)
y = -1 * sin((fvar(1)+90.0)*pi/180.0) * var(1)
persistent = 0
ignorehitpause = 1

[State 11005]
type = velset
trigger1 = 1
x = cos((fvar(1)+90.0)*pi/180.0) * var(1)
y = -1 * sin((fvar(1)+90.0)*pi/180.0) * var(1)
persistent = 0
ignorehitpause = 1

[State 11005, End]
type = destroyself
trigger1 = animtime = 0
ignorehitpause = 1

[Statedef 11006]
type = A
movetype = I
physics = N
sprpriority = 5
anim = 11009

[State 11000, Noshadow]
type = assertspecial
trigger1 = 1
flag = noshadow

[State 11006, Anim]
type = changeanim
trigger1 = ishelper(11013)
trigger2 = ishelper(11012)
trigger3 = ishelper(11011)
value = 11008
persistent = 0
ignorehitpause = 1

[State 11006, Anim]
type = changeanim
trigger1 = ishelper(11008)
value = 11010
persistent = 0
ignorehitpause = 1

[State 11006]
type = varset
trigger1 = ishelper(11008)
fv = 1
value = random%181 - 90
persistent = 0
ignorehitpause = 1

[State 11006]
type = varset
trigger1 = ishelper(11013)
fv = 1
value = random%21 - 10
persistent = 0
ignorehitpause = 1

[State 11006]
type = varset
trigger1 = ishelper(11012)
fv = 1
value = 110 + random%21
persistent = 0
ignorehitpause = 1

[State 11006]
type = varset
trigger1 = ishelper(11011)
fv = 1
value = 230 + random%21
persistent = 0
ignorehitpause = 1

[State 11006]
type = varset
trigger1 = ishelper(11014)
fv = 1
value = 35 + random%21
persistent = 0
ignorehitpause = 1

[State 11006]
type = varset
trigger1 = ishelper(11015)
fv = 1
value = 125 + random%21
persistent = 0
ignorehitpause = 1

[State 11006]
type = varset
trigger1 = ishelper(11016)
fv = 1
value = 215 + random%21
persistent = 0
ignorehitpause = 1

[State 11006]
type = varset
trigger1 = ishelper(11017)
fv = 1
value = 305 + random%21
persistent = 0
ignorehitpause = 1

[State 11006]
type = varset
trigger1 = 1
v = 1
value = 3
persistent = 0
ignorehitpause = 1

[State 11006]
type = AngleSet
trigger1 = 1
value = fvar(1)
ignorehitpause = 1

[State 11006]
type = velset
trigger1 = !ishelper(11013)
trigger1 = !ishelper(11012)
trigger1 = !ishelper(11011)
x = cos((fvar(1)+90.0)*pi/180.0) * var(1)
y = -1 * sin((fvar(1)+90.0)*pi/180.0) * var(1)
persistent = 0
ignorehitpause = 1

[State 11006]
type = velset
trigger1 = ishelper(11013)
trigger2 = ishelper(11012)
trigger3 = ishelper(11011)
x = cos((fvar(1))*pi/180.0) * var(1)
y = -1 * sin((fvar(1))*pi/180.0) * var(1)
persistent = 0
ignorehitpause = 1

[State 11006]
type = AngleDraw
trigger1 = 1
ignorehitpause = 1

[State 11006]
type = trans
trigger1 = 1
trans = add
ignorehitpause = 1

[State 11006, End]
type = destroyself
trigger1 = animtime = 0
ignorehitpause = 1



;Hyper BG Helper
[Statedef 14000]
type = A
movetype = I
physics = N
sprpriority = 0

[State 14000, Dark]
type = assertspecial
trigger1 = 1
flag = noFG
flag2 = timerfreeze
flag3 = invisible

[State 14000, Invincible]
type = nothitby
trigger1 = 1
value = ,AA,AT,AP

[State 14000, Unnoticed]
type = playerpush
trigger1 = 1
value = 0

[State 14000, Screenbound]
type = screenbound
trigger1 = 1
value = 0
movecamera = 0,0

[State 14000]
type = explod
trigger1 = 1
ID = 14001
anim = 14001
pos = -320,-40
scale = 3,.5
sprpriority = -8
removetime = -1
persistent = 0
ownpal = 1
supermovetime = 9999
pausemovetime = 9999

[State 14000]
type = explod
trigger1 = 1
ID = 14002
anim = 14002
postype = left
pos = 0,0
scale = .5,.5
;vel = 8,0
bindtime = 9999
sprpriority = -9
removetime = -1
persistent = 0
ownpal = 1
supermovetime = 9999
pausemovetime = 9999

[State 14000]
type = explod
trigger1 = 1
ID = 14002
anim = 14002
postype = left
pos = 256,0
scale = .5,.5
;vel = 8,0
bindtime = 9999
sprpriority = -9
removetime = -1
persistent = 0
ownpal = 1
supermovetime = 9999
pausemovetime = 9999

[State 14000]
type = explod
trigger1 = 1
ID = 14002
anim = 14002
postype = left
pos = -256,0
scale = .5,.5
;vel = 8,0
bindtime = 9999
sprpriority = -9
removetime = -1
persistent = 0
ownpal = 1
supermovetime = 9999
pausemovetime = 9999

[State 14000]
type = explod
trigger1 = 1
ID = 14002
anim = 14002
postype = left
pos = 512,0
scale = .5,.5
;vel = 8,0
bindtime = 9999
sprpriority = -9
removetime = -1
persistent = 0
ownpal = 1
supermovetime = 9999
pausemovetime = 9999

[State 14000, FadeIn]
type = modifyexplod
trigger1 = time < 30
trigger1 = numexplod(14001)
ID = 14001
trans = addalpha
alpha = ceil((time/30.0)*256),256-ceil((time/30.0)*256)

[State 14000, FadeIn]
type = modifyexplod
trigger1 = time < 30
trigger1 = numexplod(14002)
ID = 14002
trans = addalpha
alpha = ceil((time/30.0)*256),256-ceil((time/30.0)*256)

[State 14000, Sudden Stop]
type = changestate
trigger1 = parent, movetype = H
trigger2 = parent, ctrl = 1
trigger3 = numhelper(14000) = 2
value = 14001

[State 14000, Instant Stop]
type = changestate
trigger1 = numhelper(13000)
value = 14002

[Statedef 14001]
type = A
movetype = I
physics = N
sprpriority = 0

[State 14001, Screenbound]
type = screenbound
trigger1 = 1
value = 0
movecamera = 0,0

[State 14001, Still Dark]
type = assertspecial
trigger1 = 1
flag = noFG
flag2 = invisible

[State 14001, Invincible]
type = nothitby
trigger1 = 1
value = ,AA,AT,AP

[State 14001, Unnoticed]
type = playerpush
trigger1 = 1
value = 0

[State 14001, FadeOut]
type = modifyexplod
trigger1 = time < 30
trigger1 = numexplod(14001)
ID = 14001
trans = addalpha
alpha = 256-ceil((time/30.0)*256),ceil((time/30.0)*256)

[State 14001, FadeOut]
type = modifyexplod
trigger1 = time < 30
trigger1 = numexplod(14002)
ID = 14002
trans = addalpha
alpha = 256-ceil((time/30.0)*256),ceil((time/30.0)*256)

[State 14001, Die]
type = removeexplod
trigger1 = time = 30
ID = 14001

[State 14001, Die]
type = removeexplod
trigger1 = time = 30
ID = 14002

[State 14001, Die]
type = destroyself
trigger1 = time = 30

[Statedef 14002]
type = A
movetype = I
physics = N
sprpriority = 0

[State 14002, Die]
type = removeexplod
trigger1 = time = 0
ID = 14001

[State 14002, Die]
type = removeexplod
trigger1 = time = 0
ID = 14002

[State 14002, Die]
type = destroyself
trigger1 = time = 0


;Super finish sparks
[Statedef 13000]
type = A
movetype = I
physics = N
sprpriority = -3

[State 13000, Pretty Sounds!]
type = playsnd
trigger1 = time = 0
value = 13000,0
volume = 255

[State 13000, It's a line Luigi]
type = null
trigger1 = var(13) := (Random%320)-240

[State 13000, Assert]
type = Assertspecial
trigger1 = time < 150
flag = noBG
flag2 = noFG
flag3 = timerfreeze

[State 13000, Pause]
type = Pause
trigger1 = time = 0
time = 150
movetime = 150
pausebg = 1

[State 13000, Maek sum hueg explods]
type = explod
trigger1 = time = 0
anim = 14000
ID = 14000
postype = back
pos = -71,-92+240
random = 20,20
vel = 4,-4
bindtime = 1
removetime = 300
sprpriority = -3
scale = const(size.xscale),const(size.yscale)
pausemovetime = 999

[State 13000, Maek sum hueg explods]
type = explod
trigger1 = time = 5
anim = 14000
ID = 14000
postype = back
pos = -122,-100+240
random = 20,20
vel = 4,-4
bindtime = 1
removetime = 300
sprpriority = -3
scale = const(size.xscale),const(size.yscale)
pausemovetime = 999

[State 13000, Maek sum hueg explods]
type = explod
trigger1 = time = 3
anim = 14000
ID = 13002
postype = back
pos = 49,131+240
random = 20,20
vel = 4,-4
bindtime = 1
removetime = 300
sprpriority = -3
scale = const(size.xscale),const(size.yscale)
pausemovetime = 999

[State 13000, Maek sum less hueg explods]
type = explod
trigger1 = time = [0,75]
trigger1 = time % 3 = 0
anim = 14000
ID = 14001
postype = back
pos = var(13),var(13)+240
random = 60,60
vel = 4.3-1+(random%2),-4.3-1+(random%2)
bindtime = 1
removetime = 300
sprpriority = -3
scale = const(size.xscale)*.5,const(size.yscale)*.5
pausemovetime = 999

[State 13000, Maek sum tiny ass explods]
type = explod
trigger1 = time = [0,120]
trigger1 = time % 2 = 0
anim = 14000
ID = 14002
postype = back
pos = var(13),var(13)+240
random = 60,60
vel = 4.8-1+(random%2),-4.8-1+(random%2)
bindtime = 1
removetime = 300
sprpriority = -3
scale = const(size.xscale)*.125,const(size.yscale)*.125
pausemovetime = 999

;==================================================================
;Wall Hit (Custom State)
[Statedef 2000]
type = A
movetype = H
physics = N
sprpriority = 1
ctrl = 0

[State 2000, Freeze]
type = posfreeze
trigger1 = !hitshakeover
value = 1

[State 2000, Vel]
type = velset
trigger1 = time = 0
y = 0
x = ifelse(facing != enemy,facing,-10,10)

[State 2000, Anim]
type = ChangeAnim
Trigger1 = Time = 0
value = 5030

[State 2000, GILL]
type = ChangeAnim2
trigger1 = Name = "Gill"
trigger1 = Authorname = "GM"
trigger1 = Facing = -1
trigger1 = anim = 5030
value = 105030
elem = animelemno(0)

[State 2000, push]
type = playerpush
trigger1 = time > 0
value = 0

[State 2000, Hit wall]
type = ChangeState
trigger1 = BackEdgeBodyDist <= const(size.air.back) + 10
trigger2 = FrontEdgeBodyDist <= const(size.air.front) + 10
value = 2001

[Statedef 2001]
type    = A
movetype= H
physics = N

[State 2001, Recover!]
type = changestate
triggerall = command = "recovery"
trigger1 = time < 4
value = 2050

[State 2001, Turn]
type = turn
trigger1 = facing = enemy,facing
persistent = 0

[State 2001, Pos]
type = PosAdd
trigger1 = Time = 0
x = 15 - BackEdgeBodyDist

[State 2001, Stop moving]
type = PosFreeze
trigger1 = 1
x = 1
y = 1

[State 2001, No scroll]
type = ScreenBound
trigger1 = 1
value = 1
movecamera = 0,1

[State 2001, Spark]
type = Explod
trigger1 = Time = 0
anim = F72
pos = 0, floor (screenpos y) - 50
postype = back
sprpriority = 3
pausemovetime = 65535

[State 2001, Anim]
type = ChangeAnim2
trigger1 = Time = 0
value = 3004

[State 2001, Anim]
type = ChangeAnim2
trigger1 = Time = 0
trigger1 = Name = "Gill"
trigger1 = Authorname = "GM"
trigger1 = Facing = -1
value = 3005

[State 2001, Sound]
type = PlaySnd
trigger1 = Time = 0
value = F7,0

[State 2001, State]
type = ChangeState
trigger1 = time = 30
value = 2002

;------------------
; Hit by Fast Kung Fu Palm - bounce off wall
; (a custom gethit state)
[Statedef 2002]
type    = A
movetype= H
physics = N

[State 2002, Vel Y]
type = VelSet
trigger1 = Time = 0
y = -3.36

[State 2002, Vel X]
type = VelSet
trigger1 = Time = 0
x = 1.3

[State 2002, Gravity]
type = VelAdd
trigger1 = 1
y = .28

[State 2002, Anim 5050] ;Self falling animation
type = ChangeAnim
trigger1 = Time = 0
trigger1 = !SelfAnimExist(5052)
value = 5050

[State 2002, Anim 5052] ;Self falling animation (diagup type)
type = ChangeAnim
trigger1 = Time = 0
trigger1 = SelfAnimExist(5052)
value = 5052

[State 2002, Anim 5052] ;Self falling animation (diagup type)
type = ChangeAnim
trigger1 = Time = 0
trigger1 = Name = "Gill"
trigger1 = Authorname = "GM"
trigger1 = Facing = -1
value = 105052

[State 2002, Anim 5060] ;Coming down - normal
type = ChangeAnim
trigger1 = Vel Y > -2
trigger1 = Anim = 5050
trigger1 = SelfAnimExist(5060)
persistent = 0
value = 5060

[State 2002, Anim 5062] ;Coming down - diagup type
type = ChangeAnim
trigger1 = Vel Y > -2
trigger1 = Anim = 5052
trigger1 = SelfAnimExist(5062)
persistent = 0
value = 5062

[State 2002, Hit ground]
type = SelfState
trigger1 = (Vel y > 0) && (Pos y >= 0)
value = 5100

;----------------------------------------------------------------------------------
; WE SUNK
[Statedef 247]

[State -2, Varset]
type = varset
trigger1 = parent, hitpausetime > 0
trigger1 = !var(1)
var(1) = parent, hitpausetime
ignorehitpause = 1

[State -2, VarSet]
type = VarSet
trigger1 = var(1)
var(0) = parent, hitpausetime
ignorehitpause = 1

[State -2, Combo]
type = ParentVarSet
triggerall = parent, movetype = A
trigger1 = parent, animelemno(0) != parent, animelemno(var(1)-var(0))
trigger1 = var(1)
trigger2 = !var(1)
trigger2 = parent, movecontact
var(2) = 1
ignorehitpause = 1

[State -2, Combo]
type = ParentVarSet
triggerall = parent, movetype = A
trigger1 = parent, animelemno(0) = parent, animelemno(var(1)-var(0))
trigger1 = var(1)
trigger2 = !var(1)
trigger2 = !(parent, movecontact)
var(2) = 0
ignorehitpause = 1

[State -2, End]
type = Varset
triggerall = Var(1)
trigger1 = parent, HitPauseTime = 0
var(1) = 0
ignorehitpause = 1

[State -2, DTC]
type = DisplayToClipboard
trigger1 = NumHelper(247)
text = "Can cancel? %d"
params = parent, Var(2)

;-----------------------------------------------
;Custom aerial hit (To avoid fall.defence_up)
[Statedef 5072]
type    = U
movetype= H
physics = N
velset = 0,0

[State 5070, Whoops]
type = selfstate
trigger1 = !time
trigger1 = statetype = S
value = 5000

[State 5070, Whoops]
type = selfstate
trigger1 = !time
trigger1 = statetype = C
value = 5010

[State 5070, 1]
type = ChangeAnim 
trigger1 = 1
value = 5070

[State 5070, 2]
type = SelfState
trigger1 = HitShakeOver
value = 5071

[State 5070, 3]
type = ForceFeedback
trigger1 = time = 0
time = 12
waveform = sinesquare
ampl = 140

;---------------------------------------------------------------------------
; Override common states (use same number to override) :
;---------------------------------------------------------------------------

;---------------------------------------------------------------------------
; Initialize (at the start of the round)
[Statedef 5900]
type = S

[State 5900, 1] ;Clear all int variables
type = VarRangeSet
trigger1 = roundsexisted = 0
value = 0

[State 5900, 2] ;Clear all float variables
type = VarRangeSet
trigger1 = roundsexisted = 0
fvalue = 0
persistent = 0

[State 5900, Burst]
type = varset
trigger1 = time = 0
v = 4
value = 2

[State 5900, 3] ;Intro for round 1
type = ChangeState
trigger1 = roundno = 1
value = 190

;---------------------------------------------------------------------------
; States that are always executed (use statedef -2)
;---------------------------------------------------------------------------

[Statedef -2]


;---------------------------------------
;Combo Dampener

[State -2, Dampener]
type = varset
trigger1 = enemy, movetype != H
fv = 5
value = 1.0

[State -2, Dampener]
type = null
triggerall = movehit = 1
triggerall = var(2)
trigger1 = enemy,gethitvar(hitcount) = 1
trigger1 = fvar(3) > 0.0
trigger1 = fvar(5):=fvar(5)-fvar(3)
trigger1 = fvar(3):=0.0
trigger2 = enemy,gethitvar(hitcount) > 1
trigger2 = fvar(4) > 0.0
trigger2 = fvar(5):=fvar(5)-(fvar(4)*fvar(5))
trigger2 = fvar(4):=0.0

[State -2, Combo Dampener]
type = AttackmulSet
trigger1 = 1
value = fvar(5)
;Combo Dampener
;---------------------------------------


[State -2, Count Jumps]
type = null
triggerall = time = 1
trigger1 = prevstateno = 40 || prevstateno = 45 || prevstateno = 65 || stateno = 3150
trigger1 = var(6):=(var(6)+1)

[State -2, Reset Jumps]
type = null
trigger1 = statetype != A
trigger1 = var(6):=0

[State -2, ForGreatJustice]
type = Helper
trigger1 = numhelper(201) = 0
ID = 201
stateno = 201
pos = 99999,99999
supermovetime = 9999
pausemovetime = 9999

[State -2, HitpauseHelper]
type = Helper
trigger1 = numhelper(247) = 0
ID = 247
stateno = 247
pos = 99999,99999
supermovetime = 9999
pausemovetime = 9999

[State -2, Airdash Counter]
type = varset
trigger1 = statetype = S
trigger2 = movetype = H
v = 15
value = 0

[State -2, HitType]
type = varSet
triggerall = p2movetype = A
trigger1 = !(enemy, movecontact)
trigger1 = enemy, hitdefattr = SCA, NA, NP, NT, SA, SP, ST
v = 12
value = 1
ignorehitpause = 1

[State -2, HitType]
type = varSet
triggerall = p2movetype = A
trigger1 = !(enemy, movecontact)
trigger1 = enemy, hitdefattr = SCA, HA, HT, HP
v = 12
value = 2
ignorehitpause = 1

[State -2, HitType]
type = varSet
triggerall = alive
trigger1 = var(12) != 0
trigger1 = movetype = H
v = 13
value = var(12)
ignorehitpause = 1

[State -2, Null]
type = null
triggerall = alive
trigger1 = movetype = H
trigger1 = var(12):=0
ignorehitpause = 1

[State -2, Dying Wail]
type = PlaySnd
triggerall = !alive
trigger1 = loseko
trigger1 = var(13) = 2
trigger1 = HitShakeOver
trigger1 = 1||(var(13):=3)
value = 170,2
persistent = 0
volume = 255

[State -2, Dying Wail]
type = PlaySnd
triggerall = !alive
trigger1 = loseko
trigger1 = roundsexisted = 0
trigger1 = var(13) = 1
trigger1 = HitShakeOver
trigger1 = 1||(var(13):=0)
value = 170,0
persistent = 0
volume = 255

[State -2, Dying Wail]
type = PlaySnd
triggerall = !alive
trigger1 = loseko
trigger1 = roundsexisted > 0
trigger1 = var(13) = 1
trigger1 = HitShakeOver
trigger1 = 1||(var(13):=0)
value = 170,1
persistent = 0
volume = 255

[State -2, Burst Drain]
type = poweradd
value = -6
trigger1 = var(4) = 1

[State -2, Burst Over]
type = varset
trigger1 = power <= 0
trigger1 = var(4) = 1
trigger1 = var(3):=0||e
v = 4
value = 0

[State -2, Burst Counter]
type = varset
trigger1 = roundstate != 2
v = 4
value = 2

;================================================================================
; ------- NotHitBy fix by Caddie --------
;===============================================================================
[State -2, hitby]
type = hitby
trigger1 = life > 0
trigger1 = stateno = 5100 || stateno = 5110 || stateno = 5120
value = SCA, NA, SA, HA, NP, SP, HP, NT, ST, HT
time = 1

;---------------------------------------------------------------------------
; States that are executed when in self's state file (use statedef -3)
;---------------------------------------------------------------------------

[Statedef -3]

;I cannot remember if Davidgee made this code, or if it was The Necromancer.
[State -3, Niptra Blaze]
type = Pause
trigger1 = var(3)
trigger1 = (gametime%3)=0
trigger1 = roundstate = 2
trigger1 = movetype != H
time = 2
movetime = 2
ignorehitpause = 1

;This controller plays a sound everytime KFM lands from a jump, or
;from his back-dash.
[State -3, Landing Sound]
type = PlaySnd
triggerall = Time = 1
trigger1 = stateno = 52 ;Jump land
value = 40, 2

[State -3, Jumping Sound]
type = PlaySnd
triggerall = Time = 1
trigger1 = stateno = 40 || stateno = 65 ;Jump
value = 40, 0

[State -3, Jumping Sound]
type = PlaySnd
triggerall = Time = 1
trigger1 = stateno = 45
value = 40, 1

[State -3, Not Giving Up]
type = Null
triggerall = loseKO
trigger1 = Matchover = 0
trigger1 = anim = 5140 ;Liedead (First Rounds)
trigger1 = animelemtime(2) = 0
value = 180,3

[State -3, HyperDeath] ;Death by Hyper Move
type = ChangeAnim
persistent = 0
trigger1 = anim = 5150
trigger1 = var(13) = 3
value = 5151

[State -3, HyperDeath Explod]
type = Explod
triggerall = numexplod(5152) = 0
trigger1 = anim = 5151
trigger1 = var(13) = 3
anim = 5152
ID = 5152
pos = 0,0
postype = p1
facing = 1
bindtime = -1
removetime = -1
scale = const(size.xscale),const(size.yscale)
sprpriority = -2
shadow = 150, 70, 0
pausemovetime = 65535

[State -3, Pain]
type = playsnd
triggerall = time = 0
trigger1 = !hitshakeover
trigger1 = stateno != [120,159]
trigger1 = random = [0,700]
value = ifelse(gethitvar(animtype)<3,5000 + 10*gethitvar(animtype),5020), random%3
channel = 1
volume = 255
ignorehitpause = 1
persistent = 0

[State -3, Hyper Finish]
type = helper
trigger1 = hitdefattr = SCA, HA, HT, HP
trigger1 = p2life = 0
trigger1 = numhelper(13000) = 0
ID = 13000
stateno = 13000
pos = 99999,99999
supermovetime = 9999
pausemovetime = 9999
ignorehitpause = 1